#ifndef _RAM_CACHE
#define _RAM_CACHE
#include "esp_log.h"
#include <ESP32Time.h>
#include <Preferences.h>

#define maxSize_ 20
#define maxLength_ 251

// move to singleton according to https://stackoverflow.com/a/1008289
// used to save data/mac addresses without loosing them in deep sleep
class RtcMemory {
    public:
        static RtcMemory &getInstance(){
            static RtcMemory instance;
            return instance;
        }

        RtcMemory(RtcMemory const&) = delete;
        void operator=(RtcMemory const&) = delete;

        static void store_data(std::string message);
        String get_data_from_storage();
        bool is_data_storage_full();
        int amount_stored_data();
        void store_mac_address(uint8_t* mac);
        void get_host_mac(uint8_t* destination, bool open=false);
        bool does_host_exist();

    private:
        RtcMemory(){}
        // used for MAC storage
        Preferences preferences;
        uint8_t BROADCAST_MAC[6] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

};

#endif