#ifndef _DR26
#define _DR26

#include "Adafruit_ADS1X15.h"
#include "ForteSensor.hpp"
#include "Message.hpp"
#include "Pinout.hpp"
#include "esp_log.h"
#include <Wire.h>
#include "NoDataAvailableException.hpp"

class ForteDR26: public ForteSensor<Measurement> {
 public:
  void setup() override;
  Measurement readData() override;
  void changeGain(adsGain_t gain);
  void setChannel(int channel);
  std::list<Message> buildMessages() override;
  [[nodiscard]] SensorInformation getSensorInformation() const override;
  static Adafruit_ADS1115 ads;

 private:
  const SensorInformation
      sensorInformation{HardwareName::DRS26, SensorProtocol::Analog};
  int channel;
  bool sensorConnected = true;
};

#endif