#ifndef _INA219
#define _INA219

#include "ForteSensor.hpp"
#include "Message.hpp"
#include "Pinout.hpp"
#include "Wire.h"
#include "esp_log.h"
#include <INA219_WE.h>
#include <MeasurementTypes.h>


struct out_data_ina219 {
  Measurement shuntVoltage_mV;
  Measurement loadVoltage_V;
  Measurement busVoltage_V;
  Measurement current_mA;
  Measurement power_mW;
  bool ina219_overflow = false;
};

class ForteINA219: public ForteSensor<out_data_ina219> {
 public:
  void setup() override;
  out_data_ina219 readData() override;
  std::list<Message> buildMessages() override;
  [[nodiscard]] SensorInformation getSensorInformation() const override;

 private:
  INA219_WE ina219;
  out_data_ina219 data;
  const SensorInformation
      sensorInformation{HardwareName::INA219, SensorProtocol::I2C};
  const uint8_t INA219_BASE_ADDRESS = 0x40;

};

#endif