#include "MockSensor.hpp"
#include "MeasurementTypes.h"

static const char *TAG = "MOCK";

void MockSensor::setup() {

  ESP_LOGD(TAG, "MOCK Sensor initialized");
  delay(100);
  channel = 0;
}

Measurement MockSensor::readData() {
  // generate a random float value between 0 and 100
  float randomValue = DeepSleep::bootCount * 10 + channel;
  ESP_LOGD(TAG, "MOCK Sensor read value: %f", randomValue);
  return {randomValue, channel, NO_I2C_ADDRESS, MeasurementType::MOCK,
          ErrorType::DATA_OK};

}


void MockSensor::setChannel(int c) {
  channel = c;
}

std::list<Message> MockSensor::buildMessages() {
  std::list<Message> messages;
  auto measurement = readData();
//  Measurement
//          MockData{data, channel, NO_I2C_ADDRESS, MeasurementType::MOCK, ErrorType::DATA_OK};
  messages.emplace_back(measurement,
                        sensorInformation,
                        Time::getInstance().getEpochSeconds());
  return messages;
}

SensorInformation MockSensor::getSensorInformation() const {
  return sensorInformation;
}
