#ifndef _MOCK_SENSOR
#define _MOCK_SENSOR

#include "ForteSensor.hpp"
#include "Message.hpp"
#include "NoDataAvailableException.hpp"
#include "Pinout.hpp"
#include "esp_log.h"
#include <Wire.h>
#include <f_deep_sleep.hpp>


class MockSensor: public ForteSensor<Measurement> {
 public:
  void setup() override;
  Measurement readData() override;
  void setChannel(int channel);
  std::list<Message> buildMessages() override;
  [[nodiscard]] SensorInformation getSensorInformation() const override;

 private:
  const SensorInformation sensorInformation{HardwareName::MOCK, SensorProtocol::Mock};
  int channel;
};

#endif