#ifndef _RS485
#define _RS485

#include <MeasurementTypes.h>
#include "Message.hpp"
#include "ForteSensor.hpp"
#include "SentecSensors.h"

struct out_data_rs485 {
  float solarRadiation;
  float soilMoisture3;
  float soilTemperature3;
  float soilMoisture4;
  float soilTemperature4;
  float soilMoisture5;
  float soilTemperature5;
  float precipitation;
};

class Forte_RS485: public ForteSensor<out_data_rs485> {
 public:
  void setup() override;
  out_data_rs485 readData() override;
  std::list<Message> buildMessages() override;
  [[nodiscard]] SensorInformation getSensorInformation() const override;

 private:
  const SensorInformation
      sensorInformation{HardwareName::RS485, SensorProtocol::RS485};

};
#endif 